import random

## class of traders. 1 informed, 1 ZI


class SellerTrader():
    def __init__(self, cost):

        self.equity = 10000
        self.money = 100000
        self.proposalList=[]
        self.contractList=[]
        self.c = cost
        self.v = 0 
        

    def trade(self, tick, book):

            proposal=self.sell(book, tick)
            self.proposalList.append(proposal)
            transacted=book.compatibleProposal(proposal, tick)
            return transacted
############################ SELL  FUNTIONS ##########################
        
    def sell(self, book, tick):

                proposedPrice = random.uniform(self.c, 200)
                          
               

                myproposal = Proposal(self,-1, proposedPrice, tick)

                uncompatible=[]
                for i in book.bookBuy:
                        if i.o == self and i.p > proposedPrice:
                                uncompatible.append(i)
                for i in uncompatible:
                   book.bookBuy.remove(i)

                return myproposal





class BuyerTrader():
    def __init__(self, value):

        self.equity = 10000
        self.money = 100000
        self.proposalList=[]
        self.contractList=[]
        self.v = value
        self.c = 0
        

    def trade(self, tick, book):

            proposal=self.buy(book, tick)
            self.proposalList.append(proposal)
            transacted = book.compatibleProposal(proposal, tick)
            return transacted
############################  BUY FUNTIONS ##########################




    def buy(self,book, tick):

                proposedPrice = random.uniform(0,self.v)
                myproposal = Proposal(self, 1, proposedPrice, tick)

                uncompatible=[]
                for i in book.bookSell:
                        if i.o == self and i.p < myproposal.p:
                                uncompatible.append(i)
                for i in uncompatible:
                   book.bookSell.remove(i)

                return myproposal 




class Proposal():

        def __init__(self,owner, sellbuyFlag, price, time):

                self.o = owner
                self.p = price
                self.t = time
                self.sbf = sellbuyFlag
